3 # Copyright (c) 2006 Johannes E. Schindelin
7 # This script makes it easy to fix up commits in the middle of a series,
8 # and rearrange commits.
10 # The original idea comes from Eric W. Biederman, in
11 # http://article.gmane.org/gmane.comp.version-control.git/22407
15 git-rebase [-i] [options] [--] <upstream> [<branch>]
16 git-rebase [-i] (--continue | --abort | --skip)
19 v,verbose display a diffstat of what changed upstream
20 onto= rebase onto given branch instead of upstream
21 p,preserve-merges try to recreate merges instead of ignoring them
22 s,strategy= use the given merge strategy
23 no-ff cherry-pick all commits, even if unchanged
24 m,merge always used (no-op)
25 i,interactive always used (no-op)
27 continue continue rebasing process
28 abort abort rebasing process and restore original branch
29 skip skip current patch and continue rebasing process
30 no-verify override pre-rebase hook from stopping the operation
31 root rebase all reachable commmits up to the root(s)
32 autosquash move commits that begin with squash!/fixup! under -i
38 DOTEST="$GIT_DIR/rebase-merge"
40 # The file containing rebase commands, comments, and empty lines.
41 # This file is created by "git rebase -i" then edited by the user. As
42 # the lines are processed, they are removed from the front of this
43 # file and written to the tail of $DONE.
44 TODO="$DOTEST"/git-rebase-todo
46 # The rebase command lines that have already been processed. A line
47 # is moved here when it is first handled, before any associated user
51 # The commit message that is planned to be used for any changes that
52 # need to be committed following a user interaction.
55 # The file into which is accumulated the suggested commit message for
56 # squash/fixup commands. When the first of a series of squash/fixups
57 # is seen, the file is created and the commit message from the
58 # previous commit and from the first squash/fixup commit are written
59 # to it. The commit message for each subsequent squash/fixup commit
60 # is appended to the file as it is processed.
62 # The first line of the file is of the form
63 # # This is a combination of $COUNT commits.
64 # where $COUNT is the number of commits whose messages have been
65 # written to the file so far (including the initial "pick" commit).
66 # Each time that a commit message is processed, this line is read and
67 # updated. It is deleted just before the combined commit is made.
68 SQUASH_MSG="$DOTEST"/message-squash
70 # If the current series of squash/fixups has not yet included a squash
71 # command, then this file exists and holds the commit message of the
72 # original "pick" commit. (If the series ends without a "squash"
73 # command, then this can be used as the commit message of the combined
74 # commit without opening the editor.)
75 FIXUP_MSG="$DOTEST"/message-fixup
77 # $REWRITTEN is the name of a directory containing files for each
78 # commit that is reachable by at least one merge base of $HEAD and
79 # $UPSTREAM. They are not necessarily rewritten, but their children
80 # might be. This ensures that commits on merged, but otherwise
81 # unrelated side branches are left alone. (Think "X" in the man page's
83 REWRITTEN="$DOTEST"/rewritten
85 DROPPED="$DOTEST"/dropped
87 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
88 # GIT_AUTHOR_DATE that will be used for the commit that is currently
90 AUTHOR_SCRIPT="$DOTEST"/author-script
92 # When an "edit" rebase command is being processed, the SHA1 of the
93 # commit to be edited is recorded in this file. When "git rebase
94 # --continue" is executed, if there are any staged changes then they
95 # will be amended to the HEAD commit, but only provided the HEAD
96 # commit is still the commit to be edited. When any other rebase
97 # command is processed, this file is deleted.
100 # For the post-rewrite hook, we make a list of rewritten commits and
101 # their new sha1s. The rewritten-pending list keeps the sha1s of
102 # commits that have been processed, but not committed yet,
103 # e.g. because they are waiting for a 'squash' command.
104 REWRITTEN_LIST="$DOTEST"/rewritten-list
105 REWRITTEN_PENDING="$DOTEST"/rewritten-pending
111 OK_TO_SKIP_PRE_REBASE=
114 test "$(git config --bool rebase.autosquash)" = "true" && AUTOSQUASH=t
117 GIT_CHERRY_PICK_HELP="\
118 hint: after resolving the conflicts, mark the corrected paths
119 hint: with 'git add <paths>' and run 'git rebase --continue'"
120 export GIT_CHERRY_PICK_HELP
123 printf '%s\n' "$*" >&2
131 test $status != 0 && printf "%s\n" "$output"
140 # Output the commit message for the specified commit.
142 git cat-file commit "$1" | sed "1,/^$/d"
145 run_pre_rebase_hook () {
146 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
147 test -x "$GIT_DIR/hooks/pre-rebase"
149 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
150 echo >&2 "The pre-rebase hook refused to rebase."
156 require_clean_work_tree () {
157 # test if working tree is dirty
158 git rev-parse --verify HEAD > /dev/null &&
159 git update-index --ignore-submodules --refresh &&
160 git diff-files --quiet --ignore-submodules &&
161 git diff-index --cached --quiet HEAD --ignore-submodules -- ||
162 die "Working tree is dirty"
165 ORIG_REFLOG_ACTION="$GIT_REFLOG_ACTION"
167 comment_for_reflog () {
168 case "$ORIG_REFLOG_ACTION" in
170 GIT_REFLOG_ACTION="rebase -i ($1)"
171 export GIT_REFLOG_ACTION
177 mark_action_done () {
178 sed -e 1q < "$TODO" >> "$DONE"
179 sed -e 1d < "$TODO" >> "$TODO".new
180 mv -f "$TODO".new "$TODO"
181 count=$(sane_grep -c '^[^#]' < "$DONE")
182 total=$(($count+$(sane_grep -c '^[^#]' < "$TODO")))
183 if test "$last_count" != "$count"
186 printf "Rebasing (%d/%d)\r" $count $total
187 test -z "$VERBOSE" || echo
192 sha1_and_parents="$(git rev-list --parents -1 "$1")"
193 case "$sha1_and_parents" in
195 git diff --cc $sha1_and_parents
198 git diff-tree -p "$1^!"
203 esac > "$DOTEST"/patch
205 commit_message "$1" > "$MSG"
206 test -f "$AUTHOR_SCRIPT" ||
207 get_author_ident_from_commit "$1" > "$AUTHOR_SCRIPT"
211 echo "$1" > "$DOTEST"/stopped-sha
223 sane_grep '^[^#]' "$1" >/dev/null
226 # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
227 # GIT_AUTHOR_DATE exported from the current environment.
230 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
237 case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
238 case "$NEVER_FF" in '') ;; ?*) ff= ;; esac
239 output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
240 test -d "$REWRITTEN" &&
241 pick_one_preserving_merges "$@" && return
242 if test -n "$REBASE_ROOT"
244 output git cherry-pick "$@"
247 output git cherry-pick $ff "$@"
250 pick_one_preserving_merges () {
261 sha1=$(git rev-parse $sha1)
263 if test -f "$DOTEST"/current-commit
265 if test "$fast_forward" = t
267 while read current_commit
269 git rev-parse HEAD > "$REWRITTEN"/$current_commit
270 done <"$DOTEST"/current-commit
271 rm "$DOTEST"/current-commit ||
272 die "Cannot write current commit's replacement sha1"
276 echo $sha1 >> "$DOTEST"/current-commit
278 # rewrite parents; if none were rewritten, we can fast-forward.
280 pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
281 if test "$pend" = " "
285 while [ "$pend" != "" ]
287 p=$(expr "$pend" : ' \([^ ]*\)')
290 if test -f "$REWRITTEN"/$p
292 new_p=$(cat "$REWRITTEN"/$p)
294 # If the todo reordered commits, and our parent is marked for
295 # rewriting, but hasn't been gotten to yet, assume the user meant to
296 # drop it on top of the current HEAD
299 new_p=$(git rev-parse HEAD)
302 test $p != $new_p && fast_forward=f
303 case "$new_parents" in
305 ;; # do nothing; that parent is already there
307 new_parents="$new_parents $new_p"
311 if test -f "$DROPPED"/$p
314 replacement="$(cat "$DROPPED"/$p)"
315 test -z "$replacement" && replacement=root
316 pend=" $replacement$pend"
318 new_parents="$new_parents $p"
322 case $fast_forward in
324 output warn "Fast-forward to $sha1"
325 output git reset --hard $sha1 ||
326 die "Cannot fast-forward to $sha1"
329 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
333 # detach HEAD to current parent
334 output git checkout $first_parent 2> /dev/null ||
335 die "Cannot move HEAD to $first_parent"
338 case "$new_parents" in
340 test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
343 author_script=$(get_author_ident_from_commit $sha1)
344 eval "$author_script"
345 msg="$(commit_message $sha1)"
346 # No point in merging the first parent, that's HEAD
347 new_parents=${new_parents# $first_parent}
348 if ! do_with_author output \
349 git merge $STRATEGY -m "$msg" $new_parents
351 printf "%s\n" "$msg" > "$GIT_DIR"/MERGE_MSG
352 die_with_patch $sha1 "Error redoing merge $sha1"
354 echo "$sha1 $(git rev-parse HEAD^0)" >> "$REWRITTEN_LIST"
357 output git cherry-pick "$@" ||
358 die_with_patch $sha1 "Could not pick $sha1"
367 *1[0-9]|*[04-9]) echo "$1"th;;
374 update_squash_messages () {
375 if test -f "$SQUASH_MSG"; then
376 mv "$SQUASH_MSG" "$SQUASH_MSG".bak || exit
378 -e "1s/^# This is a combination of \(.*\) commits\./\1/p" \
379 -e "q" < "$SQUASH_MSG".bak)+1))
381 echo "# This is a combination of $COUNT commits."
382 sed -e 1d -e '2,/^./{
384 }' <"$SQUASH_MSG".bak
387 commit_message HEAD > "$FIXUP_MSG" || die "Cannot write $FIXUP_MSG"
390 echo "# This is a combination of 2 commits."
391 echo "# The first commit's message is:"
400 echo "# This is the $(nth_string $COUNT) commit message:"
406 echo "# The $(nth_string $COUNT) commit message will be skipped:"
408 commit_message $2 | sed -e 's/^/# /'
413 peek_next_command () {
414 sed -n -e "/^#/d" -e '/^$/d' -e "s/ .*//p" -e "q" < "$TODO"
417 # A squash/fixup has failed. Prepare the long version of the squash
418 # commit message, then die_with_patch. This code path requires the
419 # user to edit the combined commit message for all commits that have
420 # been squashed/fixedup so far. So also erase the old squash
421 # messages, effectively causing the combined commit to be used as the
422 # new basis for any further squash/fixups. Args: sha1 rest
423 die_failed_squash() {
424 mv "$SQUASH_MSG" "$MSG" || exit
426 cp "$MSG" "$GIT_DIR"/MERGE_MSG || exit
428 warn "Could not apply $1... $2"
432 flush_rewritten_pending() {
433 test -s "$REWRITTEN_PENDING" || return
434 newsha1="$(git rev-parse HEAD^0)"
435 sed "s/$/ $newsha1/" < "$REWRITTEN_PENDING" >> "$REWRITTEN_LIST"
436 rm -f "$REWRITTEN_PENDING"
439 record_in_rewritten() {
440 oldsha1="$(git rev-parse $1)"
441 echo "$oldsha1" >> "$REWRITTEN_PENDING"
443 case "$(peek_next_command)" in
447 flush_rewritten_pending
453 rm -f "$MSG" "$AUTHOR_SCRIPT" "$AMEND" || exit
454 read -r command sha1 rest < "$TODO"
460 comment_for_reflog pick
464 die_with_patch $sha1 "Could not apply $sha1... $rest"
465 record_in_rewritten $sha1
468 comment_for_reflog reword
472 die_with_patch $sha1 "Could not apply $sha1... $rest"
473 git commit --amend --no-post-rewrite
474 record_in_rewritten $sha1
477 comment_for_reflog edit
481 die_with_patch $sha1 "Could not apply $sha1... $rest"
482 echo "$sha1" > "$DOTEST"/stopped-sha
484 git rev-parse --verify HEAD > "$AMEND"
485 warn "Stopped at $sha1... $rest"
486 warn "You can amend the commit now, with"
488 warn " git commit --amend"
490 warn "Once you are satisfied with your changes, run"
492 warn " git rebase --continue"
505 comment_for_reflog $squash_style
507 test -f "$DONE" && has_action "$DONE" ||
508 die "Cannot '$squash_style' without a previous commit"
511 update_squash_messages $squash_style $sha1
512 author_script=$(get_author_ident_from_commit HEAD)
513 echo "$author_script" > "$AUTHOR_SCRIPT"
514 eval "$author_script"
515 output git reset --soft HEAD^
516 pick_one -n $sha1 || die_failed_squash $sha1 "$rest"
517 case "$(peek_next_command)" in
519 # This is an intermediate commit; its message will only be
520 # used in case of trouble. So use the long version:
521 do_with_author output git commit --no-verify -F "$SQUASH_MSG" ||
522 die_failed_squash $sha1 "$rest"
525 # This is the final command of this squash/fixup group
526 if test -f "$FIXUP_MSG"
528 do_with_author git commit --no-verify -F "$FIXUP_MSG" ||
529 die_failed_squash $sha1 "$rest"
531 cp "$SQUASH_MSG" "$GIT_DIR"/SQUASH_MSG || exit
532 rm -f "$GIT_DIR"/MERGE_MSG
533 do_with_author git commit --no-verify -e ||
534 die_failed_squash $sha1 "$rest"
536 rm -f "$SQUASH_MSG" "$FIXUP_MSG"
539 record_in_rewritten $sha1
542 read -r command rest < "$TODO"
544 printf 'Executing: %s\n' "$rest"
545 # "exec" command doesn't take a sha1 in the todo-list.
546 # => can't just use $sha1 here.
547 git rev-parse --verify HEAD > "$DOTEST"/stopped-sha
548 ${SHELL:-@SHELL_PATH@} -c "$rest" # Actual execution
550 if test "$status" -ne 0
552 warn "Execution failed: $rest"
553 warn "You can fix the problem, and then run"
555 warn " git rebase --continue"
559 # Run in subshell because require_clean_work_tree can die.
560 if ! (require_clean_work_tree)
562 warn "Commit or stash your changes, and then run"
564 warn " git rebase --continue"
570 warn "Unknown command: $command $sha1 $rest"
571 if git rev-parse --verify -q "$sha1" >/dev/null
573 die_with_patch $sha1 "Please fix this in the file $TODO."
575 die "Please fix this in the file $TODO."
579 test -s "$TODO" && return
581 comment_for_reflog finish &&
582 HEADNAME=$(cat "$DOTEST"/head-name) &&
583 OLDHEAD=$(cat "$DOTEST"/head) &&
584 SHORTONTO=$(git rev-parse --short $(cat "$DOTEST"/onto)) &&
585 NEWHEAD=$(git rev-parse HEAD) &&
588 message="$GIT_REFLOG_ACTION: $HEADNAME onto $SHORTONTO" &&
589 git update-ref -m "$message" $HEADNAME $NEWHEAD $OLDHEAD &&
590 git symbolic-ref HEAD $HEADNAME
593 test ! -f "$DOTEST"/verbose ||
594 git diff-tree --stat $(cat "$DOTEST"/head)..HEAD
597 test -s "$REWRITTEN_LIST" &&
598 git notes copy --for-rewrite=rebase < "$REWRITTEN_LIST" ||
599 true # we don't care if this copying failed
601 if test -x "$GIT_DIR"/hooks/post-rewrite &&
602 test -s "$REWRITTEN_LIST"; then
603 "$GIT_DIR"/hooks/post-rewrite rebase < "$REWRITTEN_LIST"
604 true # we don't care if this hook failed
608 warn "Successfully rebased and updated $HEADNAME."
620 # skip picking commits whose parents are unchanged
621 skip_unnecessary_picks () {
623 while read -r command rest
625 # fd=3 means we skip the command
626 case "$fd,$command" in
628 # pick a commit whose parent is current $ONTO -> skip
630 case "$(git rev-parse --verify --quiet "$sha1"^)" in
646 printf '%s\n' "$command${rest:+ }$rest" >&$fd
647 done <"$TODO" >"$TODO.new" 3>>"$DONE" &&
648 mv -f "$TODO".new "$TODO" &&
649 case "$(peek_next_command)" in
651 record_in_rewritten "$ONTO"
654 die "Could not skip unnecessary pick commands"
657 # check if no other options are set
659 test $# -eq 2 -a "$2" = '--' &&
661 test -z "$PRESERVE_MERGES" &&
662 test -z "$STRATEGY" &&
666 get_saved_options () {
667 test -d "$REWRITTEN" && PRESERVE_MERGES=t
668 test -f "$DOTEST"/strategy && STRATEGY="$(cat "$DOTEST"/strategy)"
669 test -f "$DOTEST"/verbose && VERBOSE=t
670 test -f "$DOTEST"/rebase-root && REBASE_ROOT=t
673 # Rearrange the todo list that has both "pick sha1 msg" and
674 # "pick sha1 fixup!/squash! msg" appears in it so that the latter
675 # comes immediately after the former, and change "pick" to
677 rearrange_squash () {
678 sed -n -e 's/^pick \([0-9a-f]*\) \(squash\)! /\1 \2 /p' \
679 -e 's/^pick \([0-9a-f]*\) \(fixup\)! /\1 \2 /p' \
681 test -s "$1.sq" || return
684 while read -r pick sha1 message
687 *" $sha1 "*) continue ;;
689 printf '%s\n' "$pick $sha1 $message"
690 while read -r squash action msg
694 printf '%s\n' "$action $squash $action! $msg"
699 done >"$1.rearranged" <"$1"
700 cat "$1.rearranged" >"$1"
701 rm -f "$1.sq" "$1.rearranged"
709 if left=${1%...*} right=${1#*...} &&
710 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
720 git rev-parse --verify "$1^0"
727 OK_TO_SKIP_PRE_REBASE=yes
732 is_standalone "$@" || usage
734 comment_for_reflog continue
736 test -d "$DOTEST" || die "No interactive rebase running"
739 git rev-parse --verify HEAD >/dev/null ||
740 die "Cannot read HEAD"
741 git update-index --ignore-submodules --refresh &&
742 git diff-files --quiet --ignore-submodules ||
743 die "Working tree is dirty"
745 # do we have anything to commit?
746 if git diff-index --cached --quiet --ignore-submodules HEAD --
748 : Nothing to commit -- skip this
750 . "$AUTHOR_SCRIPT" ||
751 die "Cannot find the author identity"
755 amend=$(git rev-parse --verify HEAD)
756 test "$amend" = $(cat "$AMEND") ||
758 You have uncommitted changes in your working tree. Please, commit them
759 first and then run 'git rebase --continue' again."
760 git reset --soft HEAD^ ||
761 die "Cannot rewind the HEAD"
763 do_with_author git commit --no-verify -F "$MSG" -e || {
764 test -n "$amend" && git reset --soft $amend
765 die "Could not commit staged changes."
769 record_in_rewritten "$(cat "$DOTEST"/stopped-sha)"
771 require_clean_work_tree
775 is_standalone "$@" || usage
777 comment_for_reflog abort
780 test -d "$DOTEST" || die "No interactive rebase running"
782 HEADNAME=$(cat "$DOTEST"/head-name)
783 HEAD=$(cat "$DOTEST"/head)
786 git symbolic-ref HEAD $HEADNAME
789 output git reset --hard $HEAD &&
794 is_standalone "$@" || usage
796 comment_for_reflog skip
799 test -d "$DOTEST" || die "No interactive rebase running"
801 output git reset --hard && do_rest
806 STRATEGY="-s "$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
815 # we use merge anyway
840 ONTO=$(parse_onto "$1") ||
841 die "Does not point to a valid commit: $1"
845 test -z "$REBASE_ROOT" -a $# -ge 1 -a $# -le 2 ||
846 test ! -z "$REBASE_ROOT" -a $# -le 1 || usage
848 die "Interactive rebase already started"
850 git var GIT_COMMITTER_IDENT >/dev/null ||
851 die "You need to set your committer info first"
853 if test -z "$REBASE_ROOT"
856 UPSTREAM=$(git rev-parse --verify "$1") || die "Invalid base"
857 test -z "$ONTO" && ONTO=$UPSTREAM
863 die "You must specify --onto when using --root"
865 run_pre_rebase_hook "$UPSTREAM_ARG" "$@"
867 comment_for_reflog start
869 require_clean_work_tree
873 output git checkout "$1" ||
874 die "Could not checkout $1"
877 HEAD=$(git rev-parse --verify HEAD) || die "No HEAD?"
878 mkdir "$DOTEST" || die "Could not create temporary $DOTEST"
880 : > "$DOTEST"/interactive || die "Could not mark as interactive"
881 git symbolic-ref HEAD > "$DOTEST"/head-name 2> /dev/null ||
882 echo "detached HEAD" > "$DOTEST"/head-name
884 echo $HEAD > "$DOTEST"/head
885 case "$REBASE_ROOT" in
887 rm -f "$DOTEST"/rebase-root ;;
889 : >"$DOTEST"/rebase-root ;;
891 echo $ONTO > "$DOTEST"/onto
892 test -z "$STRATEGY" || echo "$STRATEGY" > "$DOTEST"/strategy
893 test t = "$VERBOSE" && : > "$DOTEST"/verbose
894 if test t = "$PRESERVE_MERGES"
896 if test -z "$REBASE_ROOT"
898 mkdir "$REWRITTEN" &&
899 for c in $(git merge-base --all $HEAD $UPSTREAM)
901 echo $ONTO > "$REWRITTEN"/$c ||
902 die "Could not init rewritten commits"
905 mkdir "$REWRITTEN" &&
906 echo $ONTO > "$REWRITTEN"/root ||
907 die "Could not init rewritten commits"
909 # No cherry-pick because our first pass is to determine
910 # parents to rewrite and skipping dropped commits would
911 # prematurely end our probe
913 first_after_upstream="$(git rev-list --reverse --first-parent $UPSTREAM..$HEAD | head -n 1)"
915 MERGES_OPTION="--no-merges --cherry-pick"
918 SHORTHEAD=$(git rev-parse --short $HEAD)
919 SHORTONTO=$(git rev-parse --short $ONTO)
920 if test -z "$REBASE_ROOT"
921 # this is now equivalent to ! -z "$UPSTREAM"
923 SHORTUPSTREAM=$(git rev-parse --short $UPSTREAM)
924 REVISIONS=$UPSTREAM...$HEAD
925 SHORTREVISIONS=$SHORTUPSTREAM..$SHORTHEAD
927 REVISIONS=$ONTO...$HEAD
928 SHORTREVISIONS=$SHORTHEAD
930 git rev-list $MERGES_OPTION --pretty=oneline --abbrev-commit \
931 --abbrev=7 --reverse --left-right --topo-order \
934 while read -r shortsha1 rest
936 if test t != "$PRESERVE_MERGES"
938 printf '%s\n' "pick $shortsha1 $rest" >> "$TODO"
940 sha1=$(git rev-parse $shortsha1)
941 if test -z "$REBASE_ROOT"
944 for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
946 if test -f "$REWRITTEN"/$p -a \( $p != $ONTO -o $sha1 = $first_after_upstream \)
954 if test f = "$preserve"
956 touch "$REWRITTEN"/$sha1
957 printf '%s\n' "pick $shortsha1 $rest" >> "$TODO"
962 # Watch for commits that been dropped by --cherry-pick
963 if test t = "$PRESERVE_MERGES"
966 # Save all non-cherry-picked changes
967 git rev-list $REVISIONS --left-right --cherry-pick | \
968 sed -n "s/^>//p" > "$DOTEST"/not-cherry-picks
969 # Now all commits and note which ones are missing in
970 # not-cherry-picks and hence being dropped
971 git rev-list $REVISIONS |
974 if test -f "$REWRITTEN"/$rev -a "$(sane_grep "$rev" "$DOTEST"/not-cherry-picks)" = ""
976 # Use -f2 because if rev-list is telling us this commit is
977 # not worthwhile, we don't want to track its multiple heads,
978 # just the history of its first-parent for others that will
979 # be rebasing on top of it
980 git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$DROPPED"/$rev
981 short=$(git rev-list -1 --abbrev-commit --abbrev=7 $rev)
982 sane_grep -v "^[a-z][a-z]* $short" <"$TODO" > "${TODO}2" ; mv "${TODO}2" "$TODO"
988 test -s "$TODO" || echo noop >> "$TODO"
989 test -n "$AUTOSQUASH" && rearrange_squash "$TODO"
990 cat >> "$TODO" << EOF
992 # Rebase $SHORTREVISIONS onto $SHORTONTO
995 # p, pick = use commit
996 # r, reword = use commit, but edit the commit message
997 # e, edit = use commit, but stop for amending
998 # s, squash = use commit, but meld into previous commit
999 # f, fixup = like "squash", but discard this commit's log message
1000 # x <cmd>, exec <cmd> = Run a shell command <cmd>, and stop if it fails
1002 # If you remove a line here THAT COMMIT WILL BE LOST.
1003 # However, if you remove everything, the rebase will be aborted.
1007 has_action "$TODO" ||
1008 die_abort "Nothing to do"
1010 cp "$TODO" "$TODO".backup
1011 git_editor "$TODO" ||
1012 die_abort "Could not execute editor"
1014 has_action "$TODO" ||
1015 die_abort "Nothing to do"
1017 test -d "$REWRITTEN" || test -n "$NEVER_FF" || skip_unnecessary_picks
1019 output git checkout $ONTO || die_abort "could not detach HEAD"
1020 git update-ref ORIG_HEAD $HEAD